import java.beans.PropertyChangeSupport;
import java.beans.PropertyChangeSupport;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeListener;
import java.beans.PropertyChangeEvent;
/**
 * Introduces observed subject functionality.
 */
public abstract class ObservedElement {
  private PropertyChangeSupport listeners= new PropertyChangeSupport(this);
  /**
   * Returns the current PropertyChangeListeners
   */
  public PropertyChangeListener[] getPropertyChangeListeners() {
    return listeners.getPropertyChangeListeners();
  }
  /**
   * Removes a PropertyChangeListener
   */
  public void removePropertyChangeListener(PropertyChangeListener aListener) {
    listeners.removePropertyChangeListener(aListener);
  }
  /**
   * Adds a PropertyChangeListener to be notified
   */
  public void addPropertyChangeListener(PropertyChangeListener aListener) {
    listeners.addPropertyChangeListener(aListener);
  }
  /**
   * Fires a PropertyChange notification to all listeners
   */
  public void firePropertyChange(PropertyChangeEvent aPropertyChangeEvent) {
    listeners.firePropertyChange(aPropertyChangeEvent);
  }
}