import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeEvent;
/**
 * Namespace with observed properties.
 */
public class ObservedNamespace extends Namespace implements AbstractNamespace {
  /**
   * Fires a PropertyChangeEvent each time the method is invoked
   */
  public void addElement(ObservedModelElement anElement) {
    super.addElement(anElement);
    firePropertyChange(new PropertyChangeEvent(this, "anElement", null, anElement));
  }
  /**
   * Fires a PropertyChangeEvent each time the method is invoked
   */
  public void removeElement(ObservedModelElement anElement) {
    super.removeElement(anElement);
    firePropertyChange(new PropertyChangeEvent(this, "anElement", null, anElement));
  }
}