import java.awt.Image;
import java.awt.image.MemoryImageSource;
import java.awt.Canvas;
/**
 * 
 */
public class CanvasStrategy implements ImgProcStrategy {
  /**
   * 
   */
  public Image processRawImage(byte[] rawImage) {
    int r, g, b;
    int width = 320;
    int height = 240;
    int[] pixels = new int[width * height];
    MemoryImageSource source;
    Canvas c = new Canvas();
    // create 32 bit integer array of rgb pixels
    for (int i = 0; i < width * height; i++) {
      r = rawImage[i * 3];
      g = rawImage[i * 3 + 1];
      b = rawImage[i * 3 + 2];
      r &= 0xFF;
      g &= 0xFF;
      b &= 0xFF;
      pixels[i] = (255 << 24) | (r << 16) | (g << 8) | b;
    }
    source = new MemoryImageSource(width, height, pixels, 0, width);
    return c.createImage(source);
  }
}