import java.awt.Image;
import java.awt.image.BufferedImage;
/**
 * Default concrete image processing strategy.
 */
public class DefaultStrategy implements ImgProcStrategy {
  /**
   * Default concrete image processing strategy.
   */
  public Image processRawImage(byte[] rawImage) {
    int r, g, b;
    int width = 320;
    int height = 240;
    int[] pixels = new int[width * height];
    BufferedImage bi = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
    // create 32 bit integer array of rgb pixels
    for (int i = 0; i < width * height; i++) {
      r = rawImage[i * 3];
      g = rawImage[i * 3 + 1];
      b = rawImage[i * 3 + 2];
      r &= 0xFF;
      g &= 0xFF;
      b &= 0xFF;
      pixels[i] = (255 << 24) | (r << 16) | (g << 8) | b;
    }
    // draw onto buffered image and return
    bi.setRGB(0, 0, width, height, pixels, 0, width);
    return bi;
  }
}