/**
 * Metal look & feel window manager
 */
public class MetalWindowManager {
  public static void main(String[] args) {
    MetalWindowManager wm = new MetalWindowManager();
    System.out.println(wm + " created");
    AbstractSlider slider = wm.createAbstractSlider();
    System.out.println(slider + " created");
    AbstractColorPanel panel = wm.createAbstractColorPanel();
    System.out.println(panel + " created");
    AbstractLabel label = wm.createAbstractLabel();
    System.out.println(label + " created");
    System.out.println(slider + ".addObserver(" + panel + ")");
    slider.addObserver(panel);
    System.out.println(slider + ".addObserver(" + label + ")");
    slider.addObserver(label);
    System.out.println(slider + ".notifyObservers()");
    slider.notifyObservers();
  }
  /**
   * The concrete create operation for each product.
   */
  public AbstractColorPanel createAbstractColorPanel() {
    return new MetalColorPanel();
  }
  /**
   * The concrete create operation for each product.
   */
  public AbstractLabel createAbstractLabel() {
    return new MetalLabel();
  }
  /**
   * The concrete create operation for each product.
   */
  public AbstractSlider createAbstractSlider() {
    return new MetalSlider();
  }
}