import java.util.Vector;
import java.util.Enumeration;
/**
 * 
 */
public abstract class Slider {
  private Vector observers= new java.util.Vector();
  /**
   * Notifies attached observers of a change by invoking update.
   */
  public void notifyObserversSlider() {
    AbstractObserver observer;
    Enumeration obs = observers.elements();
    while (obs.hasMoreElements()) {
      observer = (AbstractObserver) obs.nextElement();
      observer.updateSlider(this);
    }
  }
  /**
   * Attaches observer to list.
   */
  public void addObserver(AbstractObserver anObserver) {
    observers.addElement(anObserver);
  }
  /**
   * Detaches observer from list.
   */
  public void deleteObserver(AbstractObserver anObserver) {
    observers.removeElement(anObserver);
  }
}