/**
 * Basic e-mail functionality.
 */
public abstract class AbstractEmail {
  private String route;
  private String receiver;
  private String originator;
  private boolean approved;
  private boolean delivered;
  private String content;
  /**
   * Sets the property value
   */
  public void setContent(String content) {
    this.content = content;
  }
  /**
   * Gets the property value
   */
  public String getContent() {
    return this.content;
  }
  /**
   * True when the email message has been approved.
   */
  public boolean isApproved() {
    return approved;
  }
  /**
   * True when email message has been delivered.
   */
  public boolean isDelivered() {
    return delivered;
  }
  /**
   * Sends the email message.
   */
  public void send() {
    System.out.println("Message sent");
  }
  /**
   * Approves email message.
   */
  public void approve() {
    approved = true;
    System.out.println("Message approved");
  }
  /**
   * Delivers the email message according to the route.
   */
  public void deliver() {
    delivered = true;
    System.out.println("Message delivered");
  }
  /**
   * Sends as a reply to the email message.
   */
  public void reply() {
    System.out.println("Message replied");
  }
  /**
   * Gets the property value
   */
  public String getOriginator() {
    return this.originator;
  }
  /**
   * Sets the property value
   */
  public void setOriginator(String originator) {
    this.originator = originator;
  }
  /**
   * Sets the property value
   */
  public void setReceiver(String receiver) {
    this.receiver = receiver;
  }
  /**
   * Gets the property value
   */
  public String getReceiver() {
    return this.receiver;
  }
  /**
   * Gets the property value
   */
  public String getRoute() {
    return this.route;
  }
  /**
   * Sets the property value
   */
  public void setRoute(String route) {
    this.route = route;
  }
}