import java.sql.Statement;
import java.sql.Connection;
import java.util.Date;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.io.File;
import java.io.File;
import java.util.Date;
import java.io.File;
import java.sql.ResultSet;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.awt.Image;
import java.io.File;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.ObjectOutputStream;
import javax.swing.ImageIcon;
import java.util.Date;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.awt.Image;
import java.io.File;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.ObjectInputStream;
import javax.swing.ImageIcon;
import java.awt.Image;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.DriverManager;
import java.sql.SQLException;
/**
 * Database connectivity class.
 Connects to the MySQL database "storage" and handles queries
 to the database.
@author Miro Casanova
@author Dennis Wagelaar
@version 5 November 2002
 */
public class DatabaseListener {
  private String imgPath= "testcases/scss/storage/imagedatabase/";
  private String jdbcUrl= "jdbc:mysql://localhost/storage?user=seescoa&password=seescoa";
  private Statement stmt;
  private Connection con;
  /**
   * Queries the database for an alarm.
   */
  public AlarmData queryAlarm(TimeData time, ID camID) {
    /* select message, time, millisec from alarm
       where time = t and cameraID = cid */
    
    AlarmData result = null;
    int count = 0, i = 0;
    int min = 0, max = 0;
    String ts = time.getTime();
    String tstamp = time.getTimestamp();
    String id = camID.getIDstring();
    int ms = time.getMilliSec();
    Date tm = time.getTimeAsDate();
    String message = new String();
    
    // searches for the image of the given camera that is closest to the given time
    String query = "SELECT message, time, millisec, " + "ABS(('" + tstamp + "' - time) * 1000 + (" + ms + " - millisec)) AS dtime " + "FROM alarm " + "WHERE cameraID = '" + id + "' " + "ORDER BY dtime LIMIT 1";
    
    try {
      Class.forName("org.gjt.mm.mysql.Driver");
    } catch(java.lang.ClassNotFoundException e) {
      System.err.print("ClassNotFoundException: ");
      System.err.println(e.getMessage());
    }
    
    try {
      con = DriverManager.getConnection(jdbcUrl);
      stmt = con.createStatement();
      ResultSet rs = stmt.executeQuery(query);
      while( rs.next() ) {
        message = rs.getString("message");
        tm      = rs.getTimestamp("time");
        ms      = rs.getInt("millisec");
        i++;
      }
      stmt.close();
      con.close();
      if ( i==0 ) {
        System.out.println("No alarm found");
        throw new Exception("No alarm found");
      }
    
      // Alarm exists
      time.setTimeAsDate(tm); // update date/time
      time.setMilliSec(ms); // update millisecond part
      result = new AlarmData(time, camID, message);
    } catch(SQLException ex) {
      System.err.println("SQLException: " + ex.getMessage());
    } catch (Exception ex) {
      System.out.println("Exception: Erroneous amount of events retrieved");
    }
    
    return result;
    
  }
  /**
   * Creates a image filename from an identifier.
   */
  private File createFileName(String iDString) {
    return new File(imgPath + iDString + ".img");
  }
  /**
   * Queries the database for an image.
   */
  public StorageVideoImage queryImage(TimeData time, ID camID) {
    /* select path, time, millisec from image
       where time = t and cameraID = cid */
    
    StorageVideoImage image = null;
    int count = 0, i = 0;
    String ts = time.getTime();
    String tstamp = time.getTimestamp();
    String id = camID.getIDstring();
    int min = 0, max = 0;
    int ms = time.getMilliSec();
    Date tm = time.getTimeAsDate();
    String path = new String();
    
    // searches for the image of the given camera that is closest to the given time
    String query = "SELECT path, time, millisec, " + "ABS(('" + tstamp + "' - time) * 1000 + (" + ms + " - millisec)) AS dtime " + "FROM image " + "WHERE cameraID = '" + id + "' " + "ORDER BY dtime LIMIT 1";
    
    try {
      Class.forName("org.gjt.mm.mysql.Driver");
    } catch(java.lang.ClassNotFoundException e) {
      System.err.print("ClassNotFoundException: ");
      System.err.println(e.getMessage());
    }
    
    try {
      con = DriverManager.getConnection(jdbcUrl);
      stmt = con.createStatement();
      ResultSet rs = stmt.executeQuery(query);
      while( rs.next() )
      {
        path = rs.getString("path");
        tm   = rs.getTimestamp("time");
        ms   = rs.getInt("millisec");
        i++;
      }
      stmt.close();
      con.close();
      if ( i==0 )
      {
        System.out.println("No image found");
        throw new Exception("No image found");
      }
    
      // image exists, so retrieve from file
      time.setTimeAsDate(tm); // update date/time
      time.setMilliSec(ms); // update millisecond part
      image = new StorageVideoImage(time, camID, readImageFile(new File(path)));
      } catch(SQLException ex) {
        System.err.println("SQLException: " + ex.getMessage());
      } catch (Exception ex) {
        System.out.println("Exception: Erroneous amount of images retrieved");
      }
    
      return image;
    
  }
  /**
   * Inserts an alarm into the database.
   */
  public void insertAlarm(AlarmData alarm) {
    /* insert into alarm   values (alID,cmID,tm,ms,msg) */
    
    int count = 0, ms;
    String msg, alID, cmID, tm;
    
    tm   = alarm.getTime();
    ms   = alarm.getMilliSec();
    cmID = alarm.getCameraID().getIDstring();
    msg  = alarm.getDescription();
    alID = alarm.getID().getIDstring();
    
    String query = "INSERT INTO alarm "+
      "VALUES ('"+alID+"','"+cmID+"','"+tm+"',"+ms+",'"+msg+"')";
    
    try {
      Class.forName("org.gjt.mm.mysql.Driver");
    } catch(java.lang.ClassNotFoundException e) {
      System.err.print("ClassNotFoundException: ");
      System.err.println(e.getMessage());
    }
    
    try {
      con = DriverManager.getConnection(jdbcUrl);
      stmt = con.createStatement();
      stmt.executeUpdate(query);
      stmt.close();
      con.close();
    } catch(SQLException ex) {
      System.err.println("SQLException: " + ex.getMessage());
    } catch (Exception ex) {
      System.out.println("Exception: Erroneous amount of alarms retrieved");
    }
  }
  /**
   * Creates a file using the given path and content.
   */
  private void createFile(Image img, File path) {
    ImageIcon imageIcon = null;
    
    try {
      // create output streams
      FileOutputStream fileOut = new FileOutputStream(path);
      ObjectOutputStream objectOut = new ObjectOutputStream(fileOut);
      // write the image object
      imageIcon = new ImageIcon(img);
      objectOut.writeObject(imageIcon);
      // flush & close streams
      objectOut.flush();
      objectOut.reset();
      objectOut.close();
      fileOut.close();
      // flush Image
      img.flush();
    } catch ( IOException e ) {
      System.err.println("Problems while creating an image (" + e.getMessage() + ")");
    }
  }
  /**
   * Queries the database for an event.
   */
  public EventData queryEvent(TimeData time, ID compID) {
    /* select message, time, millisec from event
       where time = t and componentID = cid */
    
    EventData result = null;
    int count = 0, i = 0;
    int min = 0, max = 0;
    int ms = time.getMilliSec();
    String ts = time.getTime();
    String tstamp = time.getTimestamp();
    String id = compID.getIDstring();
    Date tm = time.getTimeAsDate();
    String message = new String();
    
    // searches for the event of the given component that is closest to the given time
    String query = "SELECT message, time, millisec, " + "ABS(('" + tstamp + "' - time) * 1000 + (" + ms + " - millisec)) AS dtime " + "FROM event " + "WHERE componentID = '" + id + "' " + "ORDER BY dtime LIMIT 1";
    
    try {
      Class.forName("org.gjt.mm.mysql.Driver");
    } catch(java.lang.ClassNotFoundException e) {
      System.err.print("ClassNotFoundException: ");
      System.err.println(e.getMessage());
    }
    
    try {
      con = DriverManager.getConnection(jdbcUrl);
      stmt = con.createStatement();
      ResultSet rs = stmt.executeQuery(query);
      while ( rs.next() ) {
        message = rs.getString("message");
        tm      = rs.getTimestamp("time");
        ms      = rs.getInt("millisec");
        i++;
      }
      stmt.close();
      con.close();
      if ( i==0 ) {
        System.out.println("No event found");
        throw new Exception("No event found");
      }
    
      // Event exists
      time.setTimeAsDate(tm); // update date/time
      time.setMilliSec(ms); // update millisecond part
      result = new EventData(time, compID, message);
    } catch(SQLException ex) {
      System.err.println("SQLException: " + ex.getMessage());
    } catch (Exception ex) {
      System.out.println("Exception: Erroneous amount of events retrieved");
    }
    
    return result;
    
  }
  /**
   * Reads an Image object from the specified file.
   */
  private Image readImageFile(File path) {
    ImageIcon imageIcon = null;
    Image image = null;
    
    try {
      // create input streams
      FileInputStream fileIn = new FileInputStream(path);
      ObjectInputStream objectIn = new ObjectInputStream(fileIn);
      // read image object from file
      imageIcon = (ImageIcon) objectIn.readObject();
      image = imageIcon.getImage();
      // close streams
      objectIn.close();
      fileIn.close();
    } catch ( IOException e ) {
      System.err.println("Problems while reading an image from file (" + e.getMessage() + ")");
    } catch ( ClassNotFoundException ce ) {
      System.err.println("Unknown class contained in the image file (" + ce.getMessage() + ")");
    }
    
    return image;
  }
  /**
   * Inserts an image in the database.
   */
  public void insertImage(StorageVideoImage videoImage) {
    /* insert into image
       values (imID,cmID,tm,pth) */
    
    int count = 0, ms;
    String imID, tm, cmID;
    File path;
    
    tm   = videoImage.getTime();
    ms   = videoImage.getMilliSec();
    cmID = videoImage.getCameraID().getIDstring();
    imID = videoImage.getID().getIDstring();
    path = this.createFileName(imID);
    this.createFile(videoImage.getImage(), path);
    
    String query = "INSERT INTO image "+
      "VALUES ('"+imID+"','"+cmID+"','"+tm+"',"+ms+",'"+path+"')";
    
    try {
      Class.forName("org.gjt.mm.mysql.Driver");
    } catch(java.lang.ClassNotFoundException e) {
      System.err.print("ClassNotFoundException: ");
      System.err.println(e.getMessage());
    }
    
    try {
      con = DriverManager.getConnection(jdbcUrl);
      stmt = con.createStatement();
      stmt.executeUpdate(query);
      stmt.close();
      con.close();
    } catch(SQLException ex) {
      System.err.println("SQLException: " + ex.getMessage());
    } catch (Exception ex) {
      System.out.println("Exception: Erroneous amount of images retrieved");
    }
  }
  /**
   * Inserts an event in the database.
   */
  public void insertEvent(EventData event) {
    /* insert into event
       values (evID,cmID,tm,ms,msg) */
    
    int count = 0, ms;
    String msg, evID, cmID, tm;
    
    tm   = event.getTime();
    ms   = event.getMilliSec();
    cmID = event.getComponentID().getIDstring();
    msg  = event.getComment();
    evID = event.getID().getIDstring();
    
    String query = "INSERT INTO event "+
      "VALUES ('"+evID+"','"+cmID+"','"+tm+"',"+ms+",'"+msg+"')";
    
    try {
      Class.forName("org.gjt.mm.mysql.Driver");
    } catch(java.lang.ClassNotFoundException e) {
      System.err.print("ClassNotFoundException: ");
      System.err.println(e.getMessage());
    }
    
    try {
      con = DriverManager.getConnection(jdbcUrl);
      stmt = con.createStatement();
      stmt.executeUpdate(query);
      stmt.close();
      con.close();
    } catch(SQLException ex) {
      System.err.println("SQLException: " + ex.getMessage());
    } catch (Exception ex) {
      System.out.println("Exception: Erroneous amount of events retrieved");
    }
  }
}