/**
 * Title:        CoCompose
 * Copyright:    Copyright (c) 2002, 2003
 * Author:       Dennis Wagelaar
 * Organisation: University of Twente, Vrije Universiteit Brussel
 * Description:  CoCompose Design Language Tool
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License, version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *  (See the file "COPYING" that is included with this source distribution.)
 */

package constraints;

import EDU.utwente.CoCompose.lang.AbstractConcept;
import EDU.utwente.CoCompose.util.*;

/**
 * Example constraint class for use as correctness or completeness constraint.
 *
 * @author Dennis Wagelaar
 * @version 0.1.18, 22 November 2003
 */

public class NullConstraint implements Constraint
{
  //////////////////////////////////////////////////////////////////////////////
  // Public methods
  //////////////////////////////////////////////////////////////////////////////

  /**
   * Checks whether this constraint holds for the given concept.
   *
   * @param concept The concept to check the constraint for.
   * @throws CoComposeException if and only if the constraint doesn't hold.
   */
  public void check(AbstractConcept concept) throws CoComposeException
  {
    // null constraint
    System.out.println("Null constraint checked for " + concept.getLabel());
  } //check
} //class NullConstraint
